package io.tswf.groovy.bettergroovy.extensions.instance

import groovy.transform.stc.ClosureParams
import groovy.transform.stc.FirstParam

class AdditionalIterableMethods {
    static <T> void eachWith(
            Iterable<T> self,
            @DelegatesTo(
                    type="T",
                    strategy=Closure.DELEGATE_FIRST
            )
            @ClosureParams(FirstParam.FirstGenericType)
                    Closure closure)
    {
        self.each {closure(it)}
    }
}
