package io.tswf.groovy.bettergroovy.extensions.instance.ast

import org.codehaus.groovy.ast.ClassNode
import org.codehaus.groovy.ast.expr.ConstantExpression
import org.codehaus.groovy.ast.expr.Expression
import org.codehaus.groovy.classgen.asm.sc.StaticTypesTypeChooser

class AdditionalExpressionMethods {
    static StaticTypesTypeChooser staticTypeChooser = new StaticTypesTypeChooser()

    static boolean isNullX(Expression self) {
        return self instanceof ConstantExpression && self.value == null
    }

    static ClassNode tryResolveType(Expression self, ClassNode current) {
        return staticTypeChooser.resolveType(self, current)
    }
}
